'use strict';
Object.defineProperty(exports, '__esModule', { value: true });
exports.memoizeByFirst = void 0;
/**
 * Memoizes the provided function by the first argument.
 */
function memoizeByFirst(fn) {
  let cache0;
  return function memoized(a1, ...rest) {
    if (cache0 === undefined) {
      cache0 = new WeakMap();
    }
    let fnResult = cache0.get(a1);
    if (fnResult === undefined) {
      fnResult = fn(a1, ...rest);
      cache0.set(a1, fnResult);
    }
    return fnResult;
  };
}
exports.memoizeByFirst = memoizeByFirst;
